# Oracles and Random Number Generators

### API3

The [API3 Market](https://market.api3.org/lightlink) provides access to 200+ price feeds on [LightLink Mainnet](https://market.api3.org/lightlink) and [Testnet](https://market.api3.org/lightlink-sepolia-testnet). The price feeds operate as a native push oracle and can be activated instantly via the Market UI.

The price feeds are delivered by an aggregate of [first-party oracles](https://docs.api3.org/explore/airnode/why-first-party-oracles.html) using signed data and support [OEV recapture](https://docs.api3.org/explore/introduction/oracle-extractable-value.html).

Unlike traditional data feeds, reading[ ](https://docs.api3.org/explore/introduction/oracle-extractable-value.html)[API3 price feeds](https://docs.api3.org/guides/dapis/) enables dApps to auction off the right to update the price feeds to searcher bots which facilitates more efficient liquidation processes for users and LPs of DeFi money markets. The OEV recaptured is returned to the dApp.

Apart from data feeds, API3 also provides [Quantum Random Number Generation](https://docs.api3.org/explore/qrng/) on LightLink Mainnet and Testnet. QRNG is a free-to-use service that provides quantum randomness on-chain. It is powered by [Airnode](https://docs.api3.org/reference/airnode/latest/understand/), the first-party oracle that is directly operated by the [QRNG API providers](https://docs.api3.org/reference/qrng/providers.html). Read more about QRNG [here](https://docs.api3.org/reference/qrng).

Check out these guides on how to:

* [Use dAPIs on the Market](https://docs.api3.org/guides/dapis/subscribing-to-dapis/)
* [Read a dAPI](https://docs.api3.org/guides/dapis/read-a-dapi/)
* [Get started with QRNG](https://docs.api3.org/guides/qrng/)

### Pyth Network's Price Feeds

Pyth Network has launched 400+ price feeds on LightLink, powered by 95+ market participants including Cboe, Binance, OKX, and Bybit.

* [Price Feeds Contract on Pegasus Testnet](https://pegasus.lightlink.io/address/0x5D289Ad1CE59fCC25b6892e7A303dfFf3a9f7167)
* [Price Feeds Contract on Phoenix Mainnet](https://phoenix.lightlink.io/address/0xA2aa501b19aff244D90cc15a4Cf739D2725B5729)
* [Price Feeds List (chose Pyth EVM Stable)](https://pyth.network/developers/price-feed-ids#pyth-evm-stable)
* [Official Documentation](https://docs.pyth.network/price-feeds/api-reference/evm)

### Entropy RNG by Pyth Network

Entropy, Pyth Network's on-chain random number generator, provides secure random numbers for use in NFT mints, raffles, games, and more.

Please note that the chainName values are `lightlink-pegasus` for our Testnet and `lightlink-phoenix` for Mainnet.

* [Official Documentation](https://docs.pyth.network/documentation/entropy)
* [Solidity SDK](https://github.com/pyth-network/pyth-crosschain/tree/main/target_chains/ethereum/entropy_sdk/solidity#pyth-entropy-solidity-sdk)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.lightlink.io/lightlink-protocol/tools-for-developers/oracles-and-random-number-generators.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
